3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
30 if test -z "$TEST_OUTPUT_DIRECTORY"
32 # Similarly, override this to store the test-results subdir
34 TEST_OUTPUT_DIRECTORY
=$TEST_DIRECTORY
36 GIT_BUILD_DIR
="$TEST_DIRECTORY"/..
38 ################################################################
39 # It appears that people try to run tests without building...
40 "$GIT_BUILD_DIR/git" >/dev
/null
43 echo >&2 'error: you do not seem to have built git yet.'
47 .
"$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48 export PERL_PATH SHELL_PATH
50 # if --tee was passed, write the output not only to the terminal, but
51 # additionally to the file test-results/$BASENAME.out, too.
52 case "$GIT_TEST_TEE_STARTED, $* " in
54 # do not redirect again
56 *' --tee '*|
*' --va'*)
58 BASE
=test-results
/$
(basename "$0" .sh
)
59 (GIT_TEST_TEE_STARTED
=done ${SHELL_PATH} "$0" "$@" 2>&1;
60 echo $?
> $BASE.
exit) |
tee $BASE.out
61 test "$(cat $BASE.exit)" = 0
66 # For repeatability, reset the environment to known value.
72 export LANG LC_ALL PAGER TERM TZ
74 # A call to "unset" with no arguments causes at least Solaris 10
75 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
76 # deriving from the command substitution clustered with the other
78 unset VISUAL EMAIL LANGUAGE COLUMNS $
("$PERL_PATH" -e '
80 my $ok = join("|", qw(
91 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
92 print join("\n", @vars);
95 GIT_AUTHOR_EMAIL
=author@example.com
96 GIT_AUTHOR_NAME
='A U Thor'
97 GIT_COMMITTER_EMAIL
=committer@example.com
98 GIT_COMMITTER_NAME
='C O Mitter'
100 GIT_MERGE_AUTOEDIT
=no
101 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
102 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
103 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
106 # Add libc MALLOC and MALLOC_PERTURB test
107 # only if we are not executing the test with valgrind
108 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev
/null ||
109 test -n "$TEST_NO_MALLOC_CHECK"
111 setup_malloc_check
() {
114 teardown_malloc_check
() {
118 setup_malloc_check
() {
119 MALLOC_CHECK_
=3 MALLOC_PERTURB_
=165
120 export MALLOC_CHECK_ MALLOC_PERTURB_
122 teardown_malloc_check
() {
123 unset MALLOC_CHECK_ MALLOC_PERTURB_
127 # Protect ourselves from common misconfiguration to export
128 # CDPATH into the environment
134 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
136 echo "* warning: Some tests will not work if GIT_TRACE" \
137 "is set as to trace on STDERR ! *"
138 echo "* warning: Please set GIT_TRACE to something" \
139 "other than 1, 2 or true ! *"
145 # A regexp to match 5 and 40 hexdigits
146 _x05
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
147 _x40
="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
150 _z40
=0000000000000000000000000000000000000000
156 export _x05 _x40 _z40 LF
158 # Each test should start with something like this, after copyright notices:
160 # test_description='Description of this test...
161 # This test checks if command xyzzy does the right thing...
164 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
165 TERM
=$ORIGINAL_TERM &&
168 tput bold
>/dev
/null
2>&1 &&
169 tput setaf
1 >/dev
/null
2>&1 &&
170 tput sgr0
>/dev
/null
2>&1
174 while test "$#" -ne 0
177 -d|
--d|
--de|
--deb|
--debu|
--debug)
179 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
180 immediate
=t
; shift ;;
181 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
182 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
; shift ;;
183 -h|
--h|
--he|
--hel|
--help)
185 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
188 verbose_only
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
190 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
191 # Ignore --quiet under a TAP::Harness. Saying how many tests
192 # passed without the ok/not ok details is always an error.
193 test -z "$HARNESS_ACTIVE" && quiet
=t
; shift ;;
195 with_dashes
=t
; shift ;;
198 --va|
--val|
--valg|
--valgr|
--valgri|
--valgrin|
--valgrind)
202 valgrind
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
205 valgrind_only
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
208 shift ;; # was handled already
210 root
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
213 echo "error: unknown test option '$1'" >&2; exit 1 ;;
217 if test -n "$valgrind_only"
219 test -z "$valgrind" && valgrind
=memcheck
220 test -z "$verbose" && verbose_only
="$valgrind_only"
221 elif test -n "$valgrind"
234 tput bold
; tput setaf
1;; # bold red
236 tput setaf
4;; # blue
238 tput setaf
3;; # brown/yellow
240 tput setaf
2;; # green
242 tput setaf
6;; # cyan
244 test -n "$quiet" && return;;
254 test -z "$1" && test -n "$quiet" && return
261 say_color error
"error: $*"
270 test "${test_description}" != "" ||
271 error
"Test script did not set test_description."
273 if test "$help" = "t"
275 echo "$test_description"
281 if test "$verbose" = "t"
285 exec 4>/dev
/null
3>/dev
/null
294 test_external_has_tap
=0
298 if test -n "$GIT_EXIT_OK"
302 echo >&5 "FATAL: Unexpected exit with code $code"
310 # The user-facing functions are loaded from a separate file so that
311 # test_perf subshells can have them too
312 .
"$TEST_DIRECTORY/test-lib-functions.sh"
314 # You are not expected to call test_ok_ and test_failure_ directly, use
315 # the text_expect_* functions instead.
318 test_success
=$
(($test_success + 1))
319 say_color
"" "ok $test_count - $@"
323 test_failure
=$
(($test_failure + 1))
324 say_color error
"not ok $test_count - $1"
326 echo "$@" |
sed -e 's/^/# /'
327 test "$immediate" = "" ||
{ GIT_EXIT_OK
=t
; exit 1; }
330 test_known_broken_ok_
() {
331 test_fixed
=$
(($test_fixed+1))
332 say_color error
"ok $test_count - $@ # TODO known breakage vanished"
335 test_known_broken_failure_
() {
336 test_broken
=$
(($test_broken+1))
337 say_color warn
"not ok $test_count - $@ # TODO known breakage"
341 test "$debug" = "" ||
eval "$1"
344 match_pattern_list
() {
347 test -z "$*" && return 1
358 maybe_teardown_verbose
() {
359 test -z "$verbose_only" && return
360 exec 4>/dev
/null
3>/dev
/null
365 maybe_setup_verbose
() {
366 test -z "$verbose_only" && return
367 if match_pattern_list
$test_count $verbose_only
370 # Emit a delimiting blank line when going from
371 # non-verbose to verbose. Within verbose mode the
372 # delimiter is printed by test_expect_*. The choice
373 # of the initial $last_verbose is such that before
374 # test 1, we do not print it.
375 test -z "$last_verbose" && echo >&3 ""
378 exec 4>/dev
/null
3>/dev
/null
381 last_verbose
=$verbose
384 maybe_teardown_valgrind
() {
385 test -z "$GIT_VALGRIND" && return
386 GIT_VALGRIND_ENABLED
=
389 maybe_setup_valgrind
() {
390 test -z "$GIT_VALGRIND" && return
391 if test -z "$valgrind_only"
393 GIT_VALGRIND_ENABLED
=t
396 GIT_VALGRIND_ENABLED
=
397 if match_pattern_list
$test_count $valgrind_only
399 GIT_VALGRIND_ENABLED
=t
404 # This is a separate function because some tests use
405 # "return" to end a test_expect_success block early.
406 eval </dev
/null
>&3 2>&4 "$*"
415 teardown_malloc_check
417 if test -z "$immediate" ||
test $eval_ret = 0 ||
test -n "$expecting_failure"
420 test_eval_
"$test_cleanup"
421 teardown_malloc_check
423 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
431 test_count
=$
(($test_count+1))
438 maybe_teardown_valgrind
439 maybe_teardown_verbose
444 if match_pattern_list
$this_test.
$test_count $GIT_SKIP_TESTS
448 if test -z "$to_skip" && test -n "$test_prereq" &&
449 ! test_have_prereq
"$test_prereq"
456 if test "$missing_prereq" != "$test_prereq"
458 of_prereq
=" of $test_prereq"
461 say_color skip
>&3 "skipping test: $@"
462 say_color skip
"ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
471 # stub; perf-lib overrides it
472 test_at_end_hook_
() {
479 # Note: t0000 relies on $HARNESS_ACTIVE disabling the .counts
481 if test -z "$HARNESS_ACTIVE"
483 test_results_dir
="$TEST_OUTPUT_DIRECTORY/test-results"
484 mkdir
-p "$test_results_dir"
486 test_results_path
="$test_results_dir/${base%.sh}-$$.counts"
488 cat >>"$test_results_path" <<-EOF
490 success $test_success
498 if test "$test_fixed" != 0
500 say_color error
"# $test_fixed known breakage(s) vanished; please update test(s)"
502 if test "$test_broken" != 0
504 say_color warn
"# still have $test_broken known breakage(s)"
506 if test "$test_broken" != 0 ||
test "$test_fixed" != 0
508 test_remaining
=$
(( $test_count - $test_broken - $test_fixed ))
509 msg
="remaining $test_remaining test(s)"
511 test_remaining
=$test_count
512 msg
="$test_count test(s)"
514 case "$test_failure" in
516 # Maybe print SKIP message
517 if test -n "$skip_all" && test $test_count -gt 0
519 error
"Can't use skip_all after running some tests"
521 [ -z "$skip_all" ] || skip_all
=" # SKIP $skip_all"
523 if test $test_external_has_tap -eq 0
525 if test $test_remaining -gt 0
527 say_color pass
"# passed all $msg"
529 say
"1..$test_count$skip_all"
532 test -d "$remove_trash" &&
533 cd "$(dirname "$remove_trash")" &&
534 rm -rf "$(basename "$remove_trash")"
541 if test $test_external_has_tap -eq 0
543 say_color error
"# failed $test_failure among $msg"
552 if test -n "$valgrind"
556 test "$1" = "$(readlink "$2")" ||
{
564 while test -d "$2".lock
566 say
"Waiting for lock on $2."
573 make_valgrind_symlink
() {
574 # handle only executables, unless they are shell libraries that
575 # need to be in the exec-path. We will just use "#!" as a
576 # guess for a shell-script, since we have no idea what the user
577 # may have configured as the shell path.
579 test "#!" = "$(head -c 2 <"$1")" ||
582 base
=$
(basename "$1")
583 symlink_target
=$GIT_BUILD_DIR/$base
584 # do not override scripts
585 if test -x "$symlink_target" &&
586 test ! -d "$symlink_target" &&
587 test "#!" != "$(head -c 2 < "$symlink_target")"
589 symlink_target
=..
/valgrind.sh
593 symlink_target
=..
/unprocessed-script
595 # create the link, or replace it if it is out of date
596 make_symlink
"$symlink_target" "$GIT_VALGRIND/bin/$base" ||
exit
599 # override all git executables in TEST_DIRECTORY/..
600 GIT_VALGRIND
=$TEST_DIRECTORY/valgrind
601 mkdir
-p "$GIT_VALGRIND"/bin
602 for file in $GIT_BUILD_DIR/git
* $GIT_BUILD_DIR/test-
*
604 make_valgrind_symlink
$file
606 # special-case the mergetools loadables
607 make_symlink
"$GIT_BUILD_DIR"/mergetools
"$GIT_VALGRIND/bin/mergetools"
612 ls "$path"/git-
* 2> /dev
/null |
615 make_valgrind_symlink
"$file"
619 PATH
=$GIT_VALGRIND/bin
:$PATH
620 GIT_EXEC_PATH
=$GIT_VALGRIND/bin
622 GIT_VALGRIND_MODE
="$valgrind"
623 export GIT_VALGRIND_MODE
624 GIT_VALGRIND_ENABLED
=t
625 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED
=
626 export GIT_VALGRIND_ENABLED
627 elif test -n "$GIT_TEST_INSTALLED"
629 GIT_EXEC_PATH
=$
($GIT_TEST_INSTALLED/git
--exec-path) ||
630 error
"Cannot run git from $GIT_TEST_INSTALLED."
631 PATH
=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
632 GIT_EXEC_PATH
=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
633 else # normal case, use ../bin-wrappers only unless $with_dashes:
634 git_bin_dir
="$GIT_BUILD_DIR/bin-wrappers"
635 if ! test -x "$git_bin_dir/git"
637 if test -z "$with_dashes"
639 say
"$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
643 PATH
="$git_bin_dir:$PATH"
644 GIT_EXEC_PATH
=$GIT_BUILD_DIR
645 if test -n "$with_dashes"
647 PATH
="$GIT_BUILD_DIR:$PATH"
650 GIT_TEMPLATE_DIR
="$GIT_BUILD_DIR"/templates
/blt
652 GIT_CONFIG_NOSYSTEM
=1
654 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
656 if test -z "$GIT_TEST_CMP"
658 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
660 GIT_TEST_CMP
="$DIFF -c"
662 GIT_TEST_CMP
="$DIFF -u"
666 GITPERLLIB
="$GIT_BUILD_DIR"/perl
/blib
/lib
:"$GIT_BUILD_DIR"/perl
/blib
/arch
/auto
/Git
668 test -d "$GIT_BUILD_DIR"/templates
/blt ||
{
669 error
"You haven't built things yet, have you?"
672 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
674 GITPYTHONLIB
="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
676 test -d "$GIT_BUILD_DIR"/git_remote_helpers
/build ||
{
677 error
"You haven't built git_remote_helpers yet, have you?"
681 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
683 echo >&2 'You need to build test-chmtime:'
684 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
689 TRASH_DIRECTORY
="trash directory.$(basename "$0" .sh)"
690 test -n "$root" && TRASH_DIRECTORY
="$root/$TRASH_DIRECTORY"
691 case "$TRASH_DIRECTORY" in
692 /*) ;; # absolute path is good
693 *) TRASH_DIRECTORY
="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
695 test ! -z "$debug" || remove_trash
=$TRASH_DIRECTORY
696 rm -fr "$TRASH_DIRECTORY" ||
{
698 echo >&5 "FATAL: Cannot prepare test area"
702 HOME
="$TRASH_DIRECTORY"
705 if test -z "$TEST_NO_CREATE_REPO"
707 test_create_repo
"$TRASH_DIRECTORY"
709 mkdir
-p "$TRASH_DIRECTORY"
711 # Use -P to resolve symlinks in our working directory so that the cwd
712 # in subprocesses like git equals our $PWD (for pathname comparisons).
713 cd -P "$TRASH_DIRECTORY" ||
exit 1
716 this_test
=${this_test%%-*}
717 if match_pattern_list
"$this_test" $GIT_SKIP_TESTS
719 say_color info
>&3 "skipping test $this_test altogether"
720 skip_all
="skip all tests in $this_test"
724 # Provide an implementation of the 'yes' utility
739 # Fix some commands on Windows
742 # Windows has its own (incompatible) sort and find
752 # git sees Windows-style pwd
756 # no POSIX permissions
757 # backslashes in pathspec are converted to '/'
758 # exec does not inherit the PID
759 test_set_prereq MINGW
760 test_set_prereq NOT_CYGWIN
761 test_set_prereq SED_STRIPS_CR
764 test_set_prereq POSIXPERM
765 test_set_prereq EXECKEEPSPID
766 test_set_prereq NOT_MINGW
767 test_set_prereq CYGWIN
768 test_set_prereq SED_STRIPS_CR
771 test_set_prereq POSIXPERM
772 test_set_prereq BSLASHPSPEC
773 test_set_prereq EXECKEEPSPID
774 test_set_prereq NOT_MINGW
775 test_set_prereq NOT_CYGWIN
779 ( COLUMNS
=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
780 test -z "$NO_PERL" && test_set_prereq PERL
781 test -z "$NO_PYTHON" && test_set_prereq PYTHON
782 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
783 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
785 # Can we rely on git's output in the C locale?
786 if test -n "$GETTEXT_POISON"
788 GIT_GETTEXT_POISON
=YesPlease
789 export GIT_GETTEXT_POISON
790 test_set_prereq GETTEXT_POISON
792 test_set_prereq C_LOCALE_OUTPUT
795 # Use this instead of test_cmp to compare files that contain expected and
796 # actual output from git commands that can be translated. When running
797 # under GETTEXT_POISON this pretends that the command produced expected
800 test -n "$GETTEXT_POISON" || test_cmp
"$@"
803 # Use this instead of "grep expected-string actual" to see if the
804 # output from a git command that can be translated either contains an
805 # expected string, or does not contain an unwanted one. When running
806 # under GETTEXT_POISON this pretends that the command produced expected
809 if test -n "$GETTEXT_POISON"
812 elif test "x!" = "x$1"
821 test_lazy_prereq PIPE
'
822 # test whether the filesystem supports FIFOs
823 rm -f testfifo && mkfifo testfifo
826 test_lazy_prereq SYMLINKS
'
827 # test whether the filesystem supports symbolic links
828 ln -s x y && test -h y
831 test_lazy_prereq CASE_INSENSITIVE_FS
'
832 echo good >CamelCase &&
833 echo bad >camelcase &&
834 test "$(cat CamelCase)" != good
837 test_lazy_prereq UTF8_NFD_TO_NFC
'
838 # check whether FS converts nfd unicode to nfc
839 auml=$(printf "\303\244")
840 aumlcdiar=$(printf "\141\314\210")
850 test_lazy_prereq AUTOIDENT
'
851 sane_unset GIT_AUTHOR_NAME &&
852 sane_unset GIT_AUTHOR_EMAIL &&
853 git var GIT_AUTHOR_IDENT
856 # When the tests are run as root, permission tests will report that
857 # things are writable when they shouldn't be.
858 test -w / || test_set_prereq SANITY
860 GIT_UNZIP
=${GIT_UNZIP:-unzip}
861 test_lazy_prereq UNZIP
'